# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ParameterPolicyMember',
    'RegionalParameterPolicyMember',
    'GetRegionalParameterPolicyMemberResult',
]

@pulumi.output_type
class ParameterPolicyMember(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "iamPolicyNamePrincipal":
            suggest = "iam_policy_name_principal"
        elif key == "iamPolicyUidPrincipal":
            suggest = "iam_policy_uid_principal"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ParameterPolicyMember. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ParameterPolicyMember.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ParameterPolicyMember.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 iam_policy_name_principal: Optional[str] = None,
                 iam_policy_uid_principal: Optional[str] = None):
        """
        :param str iam_policy_name_principal: (Output)
               IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a
               resource is deleted and recreated with the same name, the binding will be applicable to the
               new resource. Format:
               `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/global/parameters/{{parameter_id}}`
        :param str iam_policy_uid_principal: (Output)
               IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier.
               If a resource is deleted and recreated with the same name, the binding will not be applicable to the
               new resource. Format:
               `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/global/parameters/{{uid}}`
        """
        if iam_policy_name_principal is not None:
            pulumi.set(__self__, "iam_policy_name_principal", iam_policy_name_principal)
        if iam_policy_uid_principal is not None:
            pulumi.set(__self__, "iam_policy_uid_principal", iam_policy_uid_principal)

    @property
    @pulumi.getter(name="iamPolicyNamePrincipal")
    def iam_policy_name_principal(self) -> Optional[str]:
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a
        resource is deleted and recreated with the same name, the binding will be applicable to the
        new resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/global/parameters/{{parameter_id}}`
        """
        return pulumi.get(self, "iam_policy_name_principal")

    @property
    @pulumi.getter(name="iamPolicyUidPrincipal")
    def iam_policy_uid_principal(self) -> Optional[str]:
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier.
        If a resource is deleted and recreated with the same name, the binding will not be applicable to the
        new resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/global/parameters/{{uid}}`
        """
        return pulumi.get(self, "iam_policy_uid_principal")


@pulumi.output_type
class RegionalParameterPolicyMember(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "iamPolicyNamePrincipal":
            suggest = "iam_policy_name_principal"
        elif key == "iamPolicyUidPrincipal":
            suggest = "iam_policy_uid_principal"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RegionalParameterPolicyMember. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RegionalParameterPolicyMember.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RegionalParameterPolicyMember.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 iam_policy_name_principal: Optional[str] = None,
                 iam_policy_uid_principal: Optional[str] = None):
        """
        :param str iam_policy_name_principal: (Output)
               IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a resource is
               deleted and recreated with the same name, the binding will be applicable to the new resource. Format:
               `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/{{location}}/parameters/{{parameter_id}}`
        :param str iam_policy_uid_principal: (Output)
               IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier. If
               a resource is deleted and recreated with the same name, the binding will not be applicable to the new
               resource. Format:
               `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/{{location}}/parameters/{{uid}}`
        """
        if iam_policy_name_principal is not None:
            pulumi.set(__self__, "iam_policy_name_principal", iam_policy_name_principal)
        if iam_policy_uid_principal is not None:
            pulumi.set(__self__, "iam_policy_uid_principal", iam_policy_uid_principal)

    @property
    @pulumi.getter(name="iamPolicyNamePrincipal")
    def iam_policy_name_principal(self) -> Optional[str]:
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a resource is
        deleted and recreated with the same name, the binding will be applicable to the new resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/{{location}}/parameters/{{parameter_id}}`
        """
        return pulumi.get(self, "iam_policy_name_principal")

    @property
    @pulumi.getter(name="iamPolicyUidPrincipal")
    def iam_policy_uid_principal(self) -> Optional[str]:
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier. If
        a resource is deleted and recreated with the same name, the binding will not be applicable to the new
        resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/{{location}}/parameters/{{uid}}`
        """
        return pulumi.get(self, "iam_policy_uid_principal")


@pulumi.output_type
class GetRegionalParameterPolicyMemberResult(dict):
    def __init__(__self__, *,
                 iam_policy_name_principal: str,
                 iam_policy_uid_principal: str):
        """
        :param str iam_policy_name_principal: IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a resource is
               deleted and recreated with the same name, the binding will be applicable to the new resource. Format:
               'principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/{{location}}/parameters/{{parameter_id}}'
        :param str iam_policy_uid_principal: IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier. If
               a resource is deleted and recreated with the same name, the binding will not be applicable to the new
               resource. Format:
               'principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/{{location}}/parameters/{{uid}}'
        """
        pulumi.set(__self__, "iam_policy_name_principal", iam_policy_name_principal)
        pulumi.set(__self__, "iam_policy_uid_principal", iam_policy_uid_principal)

    @property
    @pulumi.getter(name="iamPolicyNamePrincipal")
    def iam_policy_name_principal(self) -> str:
        """
        IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a resource is
        deleted and recreated with the same name, the binding will be applicable to the new resource. Format:
        'principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/{{location}}/parameters/{{parameter_id}}'
        """
        return pulumi.get(self, "iam_policy_name_principal")

    @property
    @pulumi.getter(name="iamPolicyUidPrincipal")
    def iam_policy_uid_principal(self) -> str:
        """
        IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier. If
        a resource is deleted and recreated with the same name, the binding will not be applicable to the new
        resource. Format:
        'principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/{{location}}/parameters/{{uid}}'
        """
        return pulumi.get(self, "iam_policy_uid_principal")


